<div class="account l-container-narrow u-margin-tb-50">
  <app-text-link
    class="heading-back-link"
    caret="left"
    [routerLink]="['/account']"
    >Account Management</app-text-link
  >

  <h2 class="heading-main heading-main--pad-bottom">
    TOTP Authentication
  </h2>

  <div *ngIf="!mfaRequired" class="register-step__feedback">
    <div class="u-margin-b-15">
      Make your account more secure by requiring a TOTP code after you log in.
    </div>
    <div class="u-margin-b-20">
      If you ever lose access to your codes, you can recover your account with
      your
      <app-text-link [link]="['/account/change-backup-code']"
        >backup code</app-text-link
      >.
    </div>
  </div>

  <div *ngIf="mfaRequired" class="register-step__feedback">
    <div class="u-margin-b-15">
      TOTP authentication is currently enabled on your account.
    </div>
    <div class="u-margin-b-15">
      If you no longer wish to use TOTP authentication, press the button below.
      You won't be able to disable TOTP authentication if you have a security key
      registered.
    </div>
  </div>

  <form *ngIf="mfaRequired" (sumbit)="disableMfa.emit()">
    <div class="form-field form-field--large">
      <button class="button button--primary" (click)="deactivateMfa.emit()" [disabled]="u2fList.length > 0">
        Disable TOTP Authentication
      </button>
    </div>
  </form>

  <div *ngIf="u2fList.length > 0" class="text--large u-margin-tb-20">
    You currently have at least one registered security key. Since not all browsers work with
    security keys, you must delete any registered security keys before you can disable TOTP.
  </div>

  <form *ngIf="!mfaRequired" [ngrxFormState]="form" (submit)="verifyMfa.emit()">
    <div *ngIf="step === 0" class="manage-backup-code__actions">
      <button class="button button--primary" (click)="forwardStep.emit()">
        Get Started
      </button>
    </div>
    <div class="form-field form-field--large">
      <app-form-label
        [isLarge]="true"
        [isComplete]="step > 1"
        [isInactive]="step < 1"
      >
        Download Authenticator App
      </app-form-label>
      <div *ngIf="step === 1">
        <div class="text--large u-margin-tb-20">
          Download
          <app-text-link
            isExternal="true"
            target="_blank"
            link="https://authy.com/download/"
            >Authy</app-text-link
          >,&nbsp;
          <app-text-link
            isExternal="true"
            target="_blank"
            link="https://play.google.com/store/apps/details?id=com.google.android.apps.authenticator2&hl=en_US"
            >Google Authenticator</app-text-link
          >,
          <app-text-link
            isExternal="true"
            target="_blank"
            link="https://www.microsoft.com/en-us/p/microsoft-authenticator/9nblgggzmcj6?activetab=pivot:overviewtab"
            >Windows Authenticator</app-text-link
          >, or your favorite authenticator app on you mobile device.
        </div>
        <div class="text--large text--less-bottom-margin">
          Once you have the app running, proceed to the next step.
        </div>
        <div class="manage-backup-code__actions">
          <button class="button button--primary" (click)="generateMfa.emit()">
            Next
          </button>
        </div>
      </div>
    </div>
    <div class="form-field form-field--large">
      <app-form-label
        [isLarge]="true"
        [isComplete]="step > 2"
        [isInactive]="step < 2"
      >
        Scan QR Code
      </app-form-label>

      <div *ngIf="step === 2">
        <div class="text--large text--no-bottom-margin u-margin-t-20">
          Scan the QR code in your authenticator app or enter the code below.
        </div>
        <div>
          <img style="margin-left: -14px" *ngIf="qrCode" [src]="qrCode" />
        </div>

        <div class="code-spacing">
          <a [href]="getURI()" *ngIf="uri">
            {{ uri | splitMfaLink }}
          </a>
        </div>

        <div class="manage-backup-code__actions">
          <button class="button button--primary" (click)="forwardStep.emit()">
            Next
          </button>
        </div>
      </div>
    </div>
    <div class="form-field form-field--large">
      <app-form-label
        [isLarge]="true"
        [isComplete]="step > 3"
        [isInactive]="step < 3"
        [class.u-margin-b-20]="step === 3"
      >
        Enter Code
      </app-form-label>
      <div *ngIf="step === 3">
        <app-text-field
          [isFormSubmitted]="form.isSubmitted"
          [ngrxFormControl]="form.controls.verificationCode"
        ></app-text-field>
        <ul *ngIf="errors" class="form-field__error-list">
          <li *ngFor="let error of errors" class="form-field__error">
            {{ error }}
          </li>
        </ul>
        <div class="form-field form-field--large">
          <div class="register-step__feedback">
            <span class="register-step__feedback__static-element">
              Enter the six digit code generated in your authenticator app, and
              submit this form to enable TOTP authentication.
            </span>
          </div>
        </div>
        <button class="button button--primary" (click)="verifyMfa.emit()">
          Enable TOTP Authentication
        </button>
      </div>
    </div>
  </form>
</div>
